// Program: Lesson 23, Exercise 3

#include <iostream.h>

#define TRUE  1 // see chapter 37 -- defined for the search member function
#define FALSE 0

class tree {
 public:
   tree(int val);
   ~tree(void);
   void insert(int val);
   int search(int val);
   int max(void);
   int min(void);
   unsigned int nb_nodes(void);
   unsigned int height(void);

 private:
   int my_val;
   tree* left;
   tree* right;
 };

tree :: tree(int val)
 {
   my_val = val;
   left = right = NULL;
 }

tree :: ~tree(void)
 {
   if (left != NULL)
     delete left;

   if (right != NULL)
     delete right;
 }

void tree :: insert(int val)
 {
   if (my_val == val) return ; // value already in the tree

   if (my_val < val)
     if (right == NULL)
       right = new tree(val);
     else right -> insert(val);

   if (my_val > val)
     if (left == NULL)
       left = new tree(val);
     else left -> insert(val);
 }

int tree :: search(int val)
 {
   if (my_val == val) return TRUE;

   if (my_val < val)
     if (right == NULL)
       return FALSE;
     else return right -> search(val);

   if (my_val > val)
     if (left == NULL)
       return FALSE;
     else return left -> search(val);
 }

int tree :: max(void)
 {
   if (right == NULL)
     return my_val;
   else return right -> max();
 }

int tree :: min(void)
 {
   if (left == NULL)
     return my_val;
   else return left -> min();
 }

unsigned int tree :: nb_nodes(void)
 {
   unsigned int left_nb_nodes = 0;
   unsigned int right_nb_nodes = 0;

   if (left != NULL)
     left_nb_nodes = left -> nb_nodes();
   if (right != NULL)
     right_nb_nodes = right -> nb_nodes();

   return left_nb_nodes + right_nb_nodes + 1;
 }

inline unsigned int maximum(unsigned int x, unsigned int y)
 {
   if (x > y)
     return x;
   else
     return y;
 }

unsigned int tree :: height(void)
 {
   unsigned int left_height = 0;
   unsigned int right_height = 0;

   if (left != NULL)
     left_height = left -> height();
   if (right != NULL)
     right_height = right -> height();

   return 1 + maximum(left_height, right_height);
 }

void main(void)
 {
    tree *t = new tree(5);
    t -> insert(7);
    t -> insert(3);
    t -> insert(9);
    t -> insert(4);
    t -> insert(-1);

    cout << "max value in tree: " << t -> max() << endl;
    cout << "min vlaue in tree: " << t -> min() << endl;
    cout << "number of nodes in tree: " << t -> nb_nodes() << endl;
    cout << "tree's height: " << t -> height() << endl;
    cout << "is 0 in the tree? " << t -> search(0) << endl;
    cout << "is 4 in the tree? " << t -> search(4) << endl;

    delete t;
 }
