// Program: Lesson 26 - Excercise 2

#include <iostream.h>
#include <string.h>

class computer
{
 public:
	computer(char *name, int memory);
	void	print(void);
	char* get_name(void)        { return name; }
	int	get_memory_size(void) { return memory; }

 private:
	char 	name[80];
	int	memory;
 };

computer::computer(char *name, int memory)
 {
	strcpy(computer::name, name);
	computer::memory= memory;
 }

void computer::print(void)
 {
	cout << "computer name: " << name << ", " << memory << "MByte RAM";
 }

class pentium : public computer
{
 public:
	pentium(int memory, int mhz);
	void 	print(void);
	int 	get_mhz(void) { return mhz; }
 private:
	int 	mhz;
 };

pentium::pentium(int memory, int mhz) : computer ("intel pentium", memory)
 {
	pentium::mhz = mhz;
 }

void pentium::print(void)
 {
	computer::print();
	cout << ", " << mhz << "MHZ clock rate" << endl;
 }

enum mactype {powerpc, motorolla_68000};

class macintosh : public computer
{
 public:
	macintosh(int memory, mactype type);
	void 	print(void);
	mactype	get_type(void) { return type; }
 private:
	mactype 	type;
 };

macintosh::macintosh(int memory, mactype type) : computer("apple macintosh",
							  memory)
 {
	macintosh::type = type;
 }

void macintosh::print(void)
 {
	computer::print();
	cout << ", " << ( (type==powerpc) ? "powerpc series"
					  : "motorolla 680x0 series")
	     << endl;
 }

void main(void)
 {
	cout << endl << endl;
	computer c("sun solaris", 128);
	pentium p(16, 133);
	macintosh m(8, powerpc);
	c.print(); cout << endl;
	p.print();
	m.print();
 }
