// Program: Lesson 30 - Excercise 1

#include <iostream.h>

const int MAX_ITEMS = 10;

template <class T>
class vector
{
 public:
	vector(void);
	vector(const vector<T>& v);

	vector<T>   operator+(const vector<T>& v);
	vector<T>   operator-(const vector<T>& v);
	vector<T>&  operator=(const vector<T>& v);
	T&	    operator[](int index);

 private:
	 T	    data[MAX_ITEMS];
 };

template <class T>
vector<T>::vector(void) {}

template <class T>
vector<T>::vector(const vector<T>& v) { *this = v; }

template <class T>
vector<T> vector<T>::operator+(const vector<T>& v)
 {
	vector result;

	for (int i = 0; i < MAX_ITEMS; i++)
	   result[i] = data[i] + v.data[i];
	return result;
}

template <class T>
vector<T> vector<T>::operator-(const vector<T>& v)
 {
	vector result;

	for (int i = 0; i < MAX_ITEMS; i++)
	   result[i] = data[i] - v.data[i];
	return result;
}

template <class T>
vector<T>& vector<T>::operator=(const vector<T>& v)
 {
	for (int i = 0; i < MAX_ITEMS; i++)
	   data[i] = v.data[i];
	return *this;
 }

template <class T>
T& vector<T>::operator[](int index)
 {
   return data[index];
 }


void print_int_vec (vector<int> v)
 {
    for (int i = 0; i < MAX_ITEMS; i++)
       cout << v[i] << " ";
    cout << endl;
 }


void main(void)
 {
	vector<int> v1, v2;

	// get user input for vector
	for (int i = 0; i < MAX_ITEMS; i++)
	 {
	   cout << "Enter item " << i << ": ";
	   cin >> v1[i];
	 }

	// print vector
	print_int_vec(v1);

	// add the vector to itself, and print result
	v2 = v1+v1;
	print_int_vec(v2);
 }
